/** The Weather Network WeatherEye widget
    
	Authors : 
		v1.x: Eric Senterre (esenterre[at]qc.pelmorex.com)
		v2.x: Rich Ramos (rramos[at]pelmorex.com)
	
	Copyright 2010 Pelmorex inc. 
**/


var wxEyeServer_search = "http://weyepc.pelmorex.com/DataFeedManager/PTIDataFeedManagerISAPI.dll/";
//var wxEyeServer_data = "http://weyedata.pelmorex.com/PTIWeatherEye/WeatherEye.dll/";
var wxEyeServer_data = "http://weyedata.pelmorex.com/WeatherEye/";
var currVersion = "2.1.1";
var URL = new String();
var req = new XMLHttpRequest();	
var gDoneButton, gInfoButton, timerId;
var feelslikeholder = "";
var windholder = "";
var humidityholder = "";
var pressureholder = "";
var selectedcity_en = null;
var selectedcity_fr = null;
var placecode = null;
var tempunit = null;
var lang = null;
var birthyear = null;
var gender = null;

var ObsDate = "";
var ObsPress = "";
var ObsPressTend = "";
var ObsHumid = "";
var ObsWSpeed = "";
var ObsWdir = "";
var ObsTemp = "";
var ObsHumidex = "";
var ObsWindChill = "";
var ObsFeels = "";
var ObsIcon = "";
var ObsCondEn = "";
var ObsCondFr = "";

var STDate = "";
var STF_Temp_1 = "";
var STF_Temp_2 = "";
var STF_Temp_3 = "";
var STF_Temp_4 = "";
var STF_POP_1 = "";
var STF_POP_2 = "";
var STF_POP_3 = "";
var STF_POP_4 = "";
var STF_DOW_1 = "";
var STF_DOW_2 = "";
var STF_DOW_3 = "";
var STF_DOW_4 = "";
var STF_Perno_1 = "";
var STF_Perno_2 = "";
var STF_Perno_3 = "";
var STF_Perno_4 = ""
var STF_Icon_1 = "0";
var STF_Icon_2 = "0";
var STF_Icon_3 = "0";
var STF_Icon_4 = "0";
var isIntlCity = new Boolean(false);
var citiesfound = new Boolean(true);
var WarningRegion, Warning, warningslink; 
var warningActive = new Boolean(false);
var localizedStrings = new Array;


var updateWeatherTimeout = 1000 * 60 * 30; // update data every 30mins (Playing around with that setting may get your IP banned from our servers)
var obsMappingArray=new Array(159);
var fxMappingArray=new Array(129);
var STF_Icon_Array = new Array(4);
var STF_CondEn_Array = new Array(4);
var STF_CondFr_Array = new Array(4);
var LTF_Icon_Array = new Array(5);
var LTF_CondEn_Array = new Array(5);
var LTF_CondFr_Array = new Array(5);
var placecode_Array=new Array();
var citiesEN_Array=new Array();
var citiesFR_Array=new Array();
var warn_array = new Array();
var numwarnings = 0;
var WxWarnRegion = "";
var WxWarnLink = "";
var WxWarnName = "";
var ACAWarnRegion = "";
var ACAWarnLink = "";
var ACAWarnName = "";
var updatedtext="";

function setup() {
	gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "OK", showFront);
	gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showBack);	
	
	city=widget.preferenceForKey(createPref("selectedcity_en"));
	if(typeof city == "undefined") { 
		document.getElementById("currcity").innerText = ""; 
		document.getElementById("wrap_nav").style.display="none";
		document.getElementById("cityname").style.display="none";
		document.getElementById("logo").style.display="none";
		widget.setPreferenceForKey("obs",createPref("activelayer"));
	} else { 
		document.getElementById("currcity").innerText = city; 
		document.getElementById("wrap_nav").style.display="block";
		document.getElementById("cityname").style.display="block";
		document.getElementById("logo").style.display="block";
	}
	
	lang = widget.preferenceForKey(createPref("lang"));
	if (typeof lang == "undefined")	{
		lang="en";
	}
	document.getElementById("langsetting").value = lang;
    
	tempunit=widget.preferenceForKey(createPref("tempunit"));
	if (typeof tempunit == "undefined")	{
		tempunit="C";
	}
	document.getElementById("tempunits").value=tempunit;
	
	gender=widget.preferenceForKey(createPref("gender"));
	if (typeof gender == "undefined")	{
		gender="";
	}
	document.getElementById("gendersetting").value=gender;
	
	birthyear=widget.preferenceForKey(createPref("birthyear"));
	if (typeof birthyear == "undefined")	{
		birthyear="";
	}
	document.getElementById("birthyearsetting").value=birthyear;
	
	alert(placecode);

	setLocalizedStrings(lang);
	initObsMapping();
	initFxMapping();
}

function convertDate(date) {
	lang = widget.preferenceForKey(createPref("lang"));
	if(lang=="en") { 
		var theDay=weekdaysArray_en[new Date(Date.parse(date)).getDay()];			
		var splitDate = date.split("/");
		var theMonth=monthsArray_en[splitDate[1]];
	} else {
		var theDay=weekdaysArray_fr[new Date(Date.parse(date)).getDay()];	
		var splitDate = date.split("/");
		var theMonth=monthsArray_fr[splitDate[1]];
	}

	var theDate=splitDate[2];
	var splitDate2="";
	splitDate2=theDate.split(" ");
	theDate=splitDate2[0];
	
	var theTime=splitDate2[1];
	
	var theYear=splitDate[0];

	if(lang=="en") { var updatedDate = theDay + ", " + theMonth + " " + theDate + ", " + theYear + " - " + convertTime(theTime); }
	else { var updatedDate = theDay + ", " + theDate + " " + theMonth + ", " + theYear + " - " + theTime; }
	
	updatedtext = getLocalizedString("Updated") + updatedDate;
}

function showBack() {	
	var front = document.getElementById("front");
	
	var back = document.getElementById("back");

	// Get Front Size before flipping
	document.getElementById("infoButton").style.display="none";
	
	if (window.widget) { widget.prepareForTransition("ToBack"); }
		
	front.style.display="none";
	
	back.style.display="block";

	if (window.widget) { setTimeout("widget.performTransition();", 0); }
	
	//document.getElementById("version").innerText="DEBUG: " + currVersion;
}

function showFront() {	
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget) { widget.prepareForTransition("ToFront"); }

	if (window.widget) { setTimeout("widget.performTransition();", 0); }

	document.getElementById("infoButton").style.display="block";

	gender=document.getElementById("gendersetting").value;
	widget.setPreferenceForKey(gender,createPref("gender"));
	
	birthyear=document.getElementById("birthyearsetting").value;
	widget.setPreferenceForKey(birthyear,createPref("birthyear"));
	
	placecode=widget.preferenceForKey(createPref("placecode"));
	
	if(typeof placecode!="undefined") {
		if((placecode.substr(0,2)=="CA")||(placecode.substr(0,2)=="US")) { 
			document.getElementById("nav_sterm_link").style.display="block";
		} else {
			document.getElementById("nav_sterm_link").style.display="none";
			if(activelayer=="st") { activelayer="obs"; showObs(); }
		}
	}
	
	city=widget.preferenceForKey(createPref("selectedcity_en"));
	if(typeof city == "undefined") { 
		document.getElementById("currcity").innerText = ""; 
		document.getElementById("wrap_nav").style.display="none";
		document.getElementById("cityname").style.display="none";
		document.getElementById("logo").style.display="none";
	} else { 
		document.getElementById("currcity").innerText = city; 
		document.getElementById("wrap_nav").style.display="block";
		document.getElementById("cityname").style.display="block";
		document.getElementById("logo").style.display="block";
	}
	
	activelayer = widget.preferenceForKey(createPref("activelayer"));
				
	updateWeather(activelayer);
	//updateWeather("obs");
	
	back.style.display="none";
	
	front.style.display="block";
}

function changeCity(reqcity) {
	URL = wxEyeServer_search+"SearchCity?s="+reqcity+"&p=isapps_plpcities";
	req = new XMLHttpRequest();	
	req.onreadystatechange = processSearchCity;
	req.open("GET", URL, true);
	req.overrideMimeType("text/xml; charset=iso-8859-1");
	req.send(null);
}

function processSearchCity() {
    // only if req shows "loaded"
    if (req.readyState == 4) {		
        // only if "OK"
        if (req.status == 200) {
			var results = req.responseText;
			//alert(results);
			
			var numCities=results.match(/[^\n]*\n[^\n]*/gi).length;
			alert(numCities);
			
			var splitResults = new Array();
			splitResults=results.split("|");			
			//alert(splitResults);
			
			var offset = 4; //4 values per city
					
			numEntries=numCities*offset;
			
			citiesEN_Array=new Array();
			citiesFR_Array=new Array();
			placecode_Array=new Array();

			pointer=1;
			for(i=pointer;i<numEntries;i+=offset) {
				placecode_Array[pointer-1]=splitResults[i];
				pointer++;
			}
			
			pointer=2;				
			for(j=pointer;j<numEntries;j+=offset) {
				citiesFR_Array[pointer-2]=splitResults[j];
				pointer++;
			}
			
			pointer=3;
			for(k=pointer;k<numEntries;k+=offset) {
				citiesEN_Array[pointer-3]=splitResults[k];
				pointer++;
			}
			//alert(placecode_Array);
			alert(citiesEN_Array);
			//alert(citiesFR_Array);			
			
			
			// Show a dropdown of possibilities
			var menu = null;
			menu = widget.createMenu();
			//alert(citiesEN_Array[0]);
			if (typeof citiesEN_Array[0]=="undefined") {
				citiesfound=false;
				menu.addMenuItem("No locations found");
				menu.setMenuItemEnabledAtIndex (0, false);
			} else {
				citiesfound=true;
				for (x=0; x<citiesEN_Array.length; x++){		
					//alert(citiesEN_Array[x]);
					if(lang=="en") { menu.addMenuItem(citiesEN_Array[x]); }
					else { menu.addMenuItem(citiesFR_Array[x]); }
				}
			}
				
		
			// If a menu is created, display and use it.
			var selection = menu.popup(25,50);
			
			// Force the 1st selection if none are selected
			if (selection < 0) { 
				if(lang=="en") { currcity.innerText=preferenceForKey(createPref("selectedcity_en")); }
				else { currcity.innerText=preferenceForKey(createPref("selectedcity_en")); }
			}
			
			//ASSIGN SETTINGS
			if(citiesfound) {
				selectedcity_en = citiesEN_Array[selection];
				selectedcity_fr = citiesFR_Array[selection];
				placecode = placecode_Array[selection];			
			
				if(lang=="en") { currcity.innerText=selectedcity_en; }
				else { currcity.innerText=selectedcity_fr; }		
				
				if (window.widget) {
					widget.setPreferenceForKey(selectedcity_en,createPref("selectedcity_en"));
					widget.setPreferenceForKey(selectedcity_fr,createPref("selectedcity_fr"));
					widget.setPreferenceForKey(placecode,createPref("placecode"));
					widget.setPreferenceForKey(tempunit,createPref("tempunit"));
					widget.setPreferenceForKey(lang,createPref("lang"));
					widget.setPreferenceForKey(birthyear,createPref("birthyear"));
					widget.setPreferenceForKey(gender,createPref("gender"));
				}
							
				citysearch.value = "";	
				
				activelayer = widget.preferenceForKey(createPref("activelayer"));
				
				updateWeather(activelayer);
			} 
		} else { alert("There was a problem retrieving the XML data:\n" + req.statusText); }
	}	
}

function searchAll(region) {
	URL = wxEyeServer_search+"SearchCity?s=*&p=isapps_plpcities&l=1";
	req = new XMLHttpRequest();	
	req.onreadystatechange = function() {
		// only if req shows "loaded"
		if (req.readyState == 4) {		
			// only if "OK"
			if (req.status == 200) {
				var results = req.responseText;
				//alert(results);
				
				var testSplit = new Array();
				testSplit = results.split("\r\n");
							
				var testSplit2 = new Array();
				var testArray = new Array(results.length);
				var allCityArray = new Array();
				var counter = 0;
				
				citiesEN_Array=new Array();
				citiesFR_Array=new Array();
				placecode_Array=new Array();
				
				var menu = null;
				menu = widget.createMenu();
				
				for(i=0;i<testSplit.length-1;i++) {
					allCityArray[counter] = new Array(3); 

					testSplit2=testSplit[i].split("|");
					
					citiesEN_Array[i]=testSplit2[3]; 
					citiesFR_Array[i]=testSplit2[2]; 
					placecode_Array[i]=testSplit2[1]; 
					
					var countryArray=new Array();
					countryArray=citiesEN_Array[i].split(", ");
									
					//alert(countryArray[2]);
					
					if(region=="can") {
						if(countryArray[2] == "Canada") {
							allCityArray[counter][0]=citiesEN_Array[i];
							allCityArray[counter][1]=citiesFR_Array[i];
							allCityArray[counter][2]=placecode_Array[i];
							menu.addMenuItem(allCityArray[counter][0]);
							counter++;
						}						
					}
					else if(region=="us") {
						if(countryArray[2] == "United States") {
							allCityArray[counter][0]=citiesEN_Array[i];
							allCityArray[counter][1]=citiesFR_Array[i];
							allCityArray[counter][2]=placecode_Array[i];
							menu.addMenuItem(allCityArray[counter][0]);
							counter++;
						}					
					}
					else { 
						if((countryArray[2] != "Canada")&&(countryArray[2] != "United States")) {
							allCityArray[counter][0]=citiesEN_Array[i];
							allCityArray[counter][1]=citiesFR_Array[i];
							allCityArray[counter][2]=placecode_Array[i];
							menu.addMenuItem(allCityArray[counter][0]);
							counter++;
						}
					}
				}
				//If a menu is created, display and use it.
				var selection = menu.popup(25,50);
				//alert(allCityArray[selection][0] + ", " + allCityArray[selection][1] + ", " + allCityArray[selection][2]);

				if (selection < 0) { 
					if(lang=="en") { currcity.innerText=preferenceForKey(createPref("selectedcity_en")); }
					else { currcity.innerText=preferenceForKey(createPref("selectedcity_en")); }
				}
				
				selectedcity_en = allCityArray[selection][0];
				selectedcity_fr = allCityArray[selection][1];
				placecode = allCityArray[selection][2];			
				
				if(lang=="en") { currcity.innerText=selectedcity_en; }
				else { currcity.innerText=selectedcity_fr; }		
					
				if (window.widget) {
					widget.setPreferenceForKey(selectedcity_en,createPref("selectedcity_en"));
					widget.setPreferenceForKey(selectedcity_fr,createPref("selectedcity_fr"));
					widget.setPreferenceForKey(placecode,createPref("placecode"));
					widget.setPreferenceForKey(tempunit,createPref("tempunit"));
					widget.setPreferenceForKey(lang,createPref("lang"));
					widget.setPreferenceForKey(birthyear,createPref("birthyear"));
					widget.setPreferenceForKey(gender,createPref("gender"));
				}
								
				citysearch.value = "";	
				
				activelayer = widget.preferenceForKey(createPref("activelayer"));
				
				updateWeather(activelayer);
			} else { alert("There was a problem retrieving the XML data:\n" + req.statusText); }
		}

	}
	req.open("GET", URL, true);
	req.overrideMimeType("text/xml; charset=iso-8859-1");
	req.send(null);
}


function updateWeather(activelayer) {	
	if(lang=="en") { city = widget.preferenceForKey(createPref("selectedcity_en")); }
	else { city = widget.preferenceForKey(createPref("selectedcity_fr")); }
	document.getElementById("citypagelink").innerText = city;
	citypagelinkanchor = "http://weyedata.pelmorex.com/WeatherEyeRedirect/links.asp?lang="+lang+"&product=citypage&app=widget&version="+currVersion+"&placecode="+placecode;
	document.getElementById("citypagelink").href = "javascript:widget.openURL(citypagelinkanchor)";

	// Temperature units
	tempunit = widget.preferenceForKey(createPref("tempunit"));
	if (tempunit == "F") {
		tempunitdisplay = "&deg;F";
	} else {
		tempunitdisplay = "&deg;C";
	}

	// Language
	lang = widget.preferenceForKey(createPref("lang"));
	if (typeof lang == "undefined")	{
		lang="en";
	}
    alert(lang);
    
	homepagelinkanchor = "http://weyedata.pelmorex.com/WeatherEyeRedirect/links.asp?lang="+lang+"&product=homepage&app=widget&version="+currVersion;
    
	document.getElementById("homepagelink").href = "javascript:widget.openURL(homepagelinkanchor);"; 
	
	
	placecode=widget.preferenceForKey(createPref("placecode"));
	if(typeof placecode != "undefined") {
		if(placecode.substr(0,2)=="CA") {	
			hfxlinkanchor = "http://weyedata.pelmorex.com/WeatherEyeRedirect/links.asp?lang="+lang+"&product=wxhourly&app=widget&version="+currVersion+"&placecode="+placecode;
			document.getElementById("hfxlink").href = "javascript:widget.openURL(hfxlinkanchor)";
			
			wxmapslinkanchor = "http://weyedata.pelmorex.com/WeatherEyeRedirect/links.asp?lang="+lang+"&product=maps&app=widget&version="+currVersion+"&placecode="+placecode;
			document.getElementById("wxmapslink").href = "javascript:widget.openURL(wxmapslinkanchor)";
			
			fourteendaylinkanchor = "http://weyedata.pelmorex.com/WeatherEyeRedirect/links.asp?lang="+lang+"&product=wx14day&app=widget&version="+currVersion+"&placecode="+placecode;
			document.getElementById("fourteendaylink").href = "javascript:widget.openURL(fourteendaylinkanchor)";
			
			document.getElementById("reflinks").style.display = "block";
		} else {
			document.getElementById("reflinks").style.display = "none";
		}
	}
	
	widget.setPreferenceForKey(activelayer,createPref("activelayer"));
	
	if(activelayer=="obs") {
		var rnd = Math.floor(Math.random()*1000000);
		URL = wxEyeServer_data+"ObsData/"+placecode+".xml?rnd="+rnd;		
		req = new XMLHttpRequest();		
		req.onreadystatechange=getObsData;
	} else {
		var rnd = Math.floor(Math.random()*1000000);
		URL = wxEyeServer_data+"FxData/"+placecode+".xml?rnd="+rnd;			
		req = new XMLHttpRequest();		
		req.onreadystatechange=getFxData;
	}
	req.open("GET", URL, true);	
	req.send(null);
}

function getObsData() {
	if (req.readyState==4) {
		status = req.status;
		
		if (status == 200) {
			var xml = req.responseXML;
			
			if (typeof xml != "undefined" || xml.getElementsByTagName("ERROR").length == 0) {
				//----- OBS BEGIN
				tagname = xml.getElementsByTagName("Observation");
				if (tagname.length > 0) {
					ObsDate = tagname[0].getAttribute("dtobs");
					ObsTemp = tagname[0].getAttribute("temp");
					ObsFeels = tagname[0].getAttribute("feelsLike");					
					ObsIcon = tagname[0].getAttribute("wxIcon");
					ObsHumid = tagname[0].getAttribute("humidity");
					ObsPress = tagname[0].getAttribute("press");
					ObsPressTend = tagname[0].getAttribute("pressTend");
					ObsWdir = tagname[0].getAttribute("wDir");
					if (lang != "fr") {	ObsWdir = ObsWdir.replace(/O/g, "W"); }
					ObsWSpeed = tagname[0].getAttribute("wSpeed");
					
					for(i=0;i<obsMappingArray.length;i++) {
						if(obsMappingArray[i][0]==ObsIcon) { 
							ObsIcon=obsMappingArray[i][1]; 
							ObsCondEn=obsMappingArray[i][2];
							ObsCondFr=obsMappingArray[i][3];
						}
					}
					showObs();
				} //--- OBS END	
			}
		}
	}
}

function getFxData() {	
	
	if (req.readyState==4) {
		status = req.status;
		
		if (status == 200) {
			var xml = req.responseXML;
            alert(xml);
			activelayer = widget.preferenceForKey(createPref("activelayer"));
			if (typeof xml != "undefined" || xml.getElementsByTagName("ERROR").length == 0) {
	
				//--- SHORT TERM BEGIN
				if(activelayer=="st") {					
					tagname=xml.getElementsByTagName("ShortTerm");
					if (tagname.length > 0) {					
						STDate = tagname[0].getAttribute("dtfx");
						
						STF_Perno_1 = tagname[0].childNodes[0].getAttribute("perno");
                        alert(STF_Perno_1);
						STF_Perno_2 = tagname[0].childNodes[1].getAttribute("perno");
						STF_Perno_3 = tagname[0].childNodes[2].getAttribute("perno");
						STF_Perno_4 = tagname[0].childNodes[3].getAttribute("perno");
								
						STF_Temp_1 = tagname[0].childNodes[0].getAttribute("temp");
						STF_Temp_2 = tagname[0].childNodes[1].getAttribute("temp");
						STF_Temp_3 = tagname[0].childNodes[2].getAttribute("temp");
						STF_Temp_4 = tagname[0].childNodes[3].getAttribute("temp");					
		
						STF_POP_1 = tagname[0].childNodes[0].getAttribute("pop");
						STF_POP_2 = tagname[0].childNodes[1].getAttribute("pop");
						STF_POP_3 = tagname[0].childNodes[2].getAttribute("pop");
						STF_POP_4 = tagname[0].childNodes[3].getAttribute("pop");
		
						STF_DOW_1 = tagname[0].childNodes[0].getAttribute("dow");
						STF_DOW_2 = tagname[0].childNodes[1].getAttribute("dow");
						STF_DOW_3 = tagname[0].childNodes[2].getAttribute("dow");
						STF_DOW_4 = tagname[0].childNodes[3].getAttribute("dow");	
						
						STF_Icon_1 = tagname[0].childNodes[0].getAttribute("wxIcon");
						STF_Icon_2 = tagname[0].childNodes[1].getAttribute("wxIcon");
						STF_Icon_3 = tagname[0].childNodes[2].getAttribute("wxIcon");
						STF_Icon_4 = tagname[0].childNodes[3].getAttribute("wxIcon");	
						STF_Icon_Array = [STF_Icon_1,STF_Icon_2,STF_Icon_3,STF_Icon_4]; 
						
						for(x=0;x<4;x++) {									
							for(i=0;i<fxMappingArray.length;i++) {
								if(fxMappingArray[i][0] == STF_Icon_Array[x]) { 
									STF_Icon_Array[x] = fxMappingArray[i][1]; 
									STF_CondEn_Array[x] = fxMappingArray[i][2]; 
									STF_CondFr_Array[x] = fxMappingArray[i][3];
								}
							}
						}
					}
					showST();
				}//--- SHORT TERM END
				
				//--- LONG TERM BEGIN
				else { 
					tagname=xml.getElementsByTagName("LongTerm");
					
					if (tagname.length > 0) {					
						LTDate = tagname[0].getAttribute("dtfx");
						
						LTF_Temp_1 = tagname[0].childNodes[0].getAttribute("tempMax");
						LTF_Temp_2 = tagname[0].childNodes[1].getAttribute("tempMax");
						LTF_Temp_3 = tagname[0].childNodes[2].getAttribute("tempMax");
						LTF_Temp_4 = tagname[0].childNodes[3].getAttribute("tempMax");		
						LTF_Temp_5 = tagname[0].childNodes[4].getAttribute("tempMax");		
		
						LTF_Low_1 = tagname[0].childNodes[0].getAttribute("tempMin");
						LTF_Low_2 = tagname[0].childNodes[1].getAttribute("tempMin");
						LTF_Low_3 = tagname[0].childNodes[2].getAttribute("tempMin");
						LTF_Low_4 = tagname[0].childNodes[3].getAttribute("tempMin");
						LTF_Low_5 = tagname[0].childNodes[4].getAttribute("tempMin");
		
						LTF_DOW_1 = tagname[0].childNodes[0].getAttribute("dow");
						LTF_DOW_2 = tagname[0].childNodes[1].getAttribute("dow");
						LTF_DOW_3 = tagname[0].childNodes[2].getAttribute("dow");
						LTF_DOW_4 = tagname[0].childNodes[3].getAttribute("dow");
						LTF_DOW_5 = tagname[0].childNodes[4].getAttribute("dow");
						
						/*LTF_Date_1 = tagname[0].childNodes[0].getAttribute("day");
						LTF_Date_2 = tagname[0].childNodes[1].getAttribute("day");
						LTF_Date_3 = tagname[0].childNodes[2].getAttribute("day");
						LTF_Date_4 = tagname[0].childNodes[3].getAttribute("day");	
						LTF_Date_5 = tagname[0].childNodes[4].getAttribute("day");	
						
						LTF_Month_1 = tagname[0].childNodes[0].getAttribute("month");
						LTF_Month_2 = tagname[0].childNodes[1].getAttribute("month");
						LTF_Month_3 = tagname[0].childNodes[2].getAttribute("month");
						LTF_Month_4 = tagname[0].childNodes[3].getAttribute("month");	
						LTF_Month_5 = tagname[0].childNodes[4].getAttribute("month");*/
						
						LTF_Icon_1 = tagname[0].childNodes[0].getAttribute("wxIcon");
						LTF_Icon_2 = tagname[0].childNodes[1].getAttribute("wxIcon");
						LTF_Icon_3 = tagname[0].childNodes[2].getAttribute("wxIcon");
						LTF_Icon_4 = tagname[0].childNodes[3].getAttribute("wxIcon");	
						LTF_Icon_5 = tagname[0].childNodes[4].getAttribute("wxIcon");	
	
						LTF_Icon_Array = [LTF_Icon_1,LTF_Icon_2,LTF_Icon_3,LTF_Icon_4,LTF_Icon_5]; 
						
						for(x=0;x<5;x++) {
							for(i=0;i<fxMappingArray.length;i++) {
								if(fxMappingArray[i][0] == LTF_Icon_Array[x]) { 
									LTF_Icon_Array[x] = fxMappingArray[i][1]; 
									LTF_CondEn_Array[x] = fxMappingArray[i][2]; 
									LTF_CondFr_Array[x] = fxMappingArray[i][3];
								}
							}
						}
					}
					showLT();
				} //LONG TERM END
			}
		}
	}
	
	/*activelayer = widget.preferenceForKey(createPref("activelayer"));
	
	if(activelayer=="st") { showST(); }
	else if(activelayer=="lt") { showLT(); }
	else { showObs(); }*/
	//showObs();
	//showLT();
}

function showObs() {
	resetObs();
	
	checkVersion();
	
	lang=widget.preferenceForKey(createPref("lang"));
	
	
	if(ObsTemp=="") { document.getElementById("nodata").innerHTML = getLocalizedString("NoData"); }
	else {	
		document.getElementById("nodata").innerHTML = ""; 
		 
		updateWarnings();
		
		widget.setPreferenceForKey("obs",createPref("activelayer"));
		
		if(typeof ObsDate != "undefined") { 
			if (ObsDate!="") { convertDate(ObsDate); }
		}
		
		document.getElementById("obsicon").src = "images/icons/large/"+ObsIcon+".png";
		
		document.getElementById("obstemp").innerHTML = convertTemp(ObsTemp)+"<sup>"+tempunitdisplay+"</sup>";
		
		if (lang == "fr") { 
			if(ObsCondFr!="") { document.getElementById("obscond").innerHTML = ObsCondFr; }
		} else { 
			if(ObsCondEn!="") { document.getElementById("obscond").innerHTML = ObsCondEn; }
		}
		
		document.getElementById("updated").innerHTML = updatedtext;
	
		
		if(ObsFeels!=ObsTemp) {
			if(ObsFeels != "") { 
				feelslikeholder = getLocalizedString("Feels") + convertTemp(ObsFeels) + "<br />"; 
			} else { 
				feelslikeholder = "";
			}
		}
		
		if(typeof ObsWdir != "undefined") { windholder = getLocalizedString("Wind") + ObsWdir + " " + ObsWSpeed + "km/h<br />"; }
		
		humidityholder = getLocalizedString("Humidity") + ObsHumid + "%<br />";
		
		pressureholder = getLocalizedString("Pressure") + ObsPress;
		
		document.getElementById("detailedobs").innerHTML = feelslikeholder + windholder + humidityholder + pressureholder;
	}
	
	document.getElementById("wrap_sterm").style.display="none";
	document.getElementById("wrap_lterm").style.display="none";	
	document.getElementById("nav_current_link").style.color="#fd0";
	document.getElementById("nav_sterm_link").style.color="#fff";
	document.getElementById("nav_lterm_link").style.color="#fff";	
	document.getElementById("wrap_obs").style.display="block";
	
	makePOSTRequest("Observations");
}

function showST() {		
	resetST();
	
	checkVersion();
	
	lang=widget.preferenceForKey(createPref("lang"));

	//convertDate(STDate);
	
		document.getElementById("st_icon1").src = "images/icons/small/"+STF_Icon_Array[0]+".png";
		document.getElementById("st_icon2").src = "images/icons/small/"+STF_Icon_Array[1]+".png";
		document.getElementById("st_icon3").src = "images/icons/small/"+STF_Icon_Array[2]+".png";
		document.getElementById("st_icon4").src = "images/icons/small/"+STF_Icon_Array[3]+".png";
		
		document.getElementById("st_temp1").innerHTML = convertTemp(STF_Temp_1)+tempunitdisplay;
		document.getElementById("st_temp2").innerHTML = convertTemp(STF_Temp_2)+tempunitdisplay;
		document.getElementById("st_temp3").innerHTML = convertTemp(STF_Temp_3)+tempunitdisplay;
		document.getElementById("st_temp4").innerHTML = convertTemp(STF_Temp_4)+tempunitdisplay;
		
		document.getElementById("st_pop1").innerText = getLocalizedString("POP")+STF_POP_1+"%";
		document.getElementById("st_pop2").innerText = getLocalizedString("POP")+STF_POP_2+"%";
		document.getElementById("st_pop3").innerText = getLocalizedString("POP")+STF_POP_3+"%";
		document.getElementById("st_pop4").innerText = getLocalizedString("POP")+STF_POP_4+"%";
	
		//If period is "Overnight", set day of the period back to the previous day.
		if(STF_Perno_1==2) { --STF_DOW_1; }
		if(STF_Perno_2==2) { --STF_DOW_2; }
		if(STF_Perno_3==2) { --STF_DOW_3; }
		if(STF_Perno_4==2) { --STF_DOW_4; }
	
		if(lang=="en") {
			document.getElementById("st_day1").innerHTML = weekdaysArray_en[STF_DOW_1].substr(0,3)+". "+periodsArray_en[STF_Perno_1];
			document.getElementById("st_day2").innerHTML = weekdaysArray_en[STF_DOW_2].substr(0,3)+". "+periodsArray_en[STF_Perno_2];
			document.getElementById("st_day3").innerHTML = weekdaysArray_en[STF_DOW_3].substr(0,3)+". "+periodsArray_en[STF_Perno_3];
			document.getElementById("st_day4").innerHTML = weekdaysArray_en[STF_DOW_4].substr(0,3)+". "+periodsArray_en[STF_Perno_4];
			document.getElementById("st_cond1").innerText = STF_CondEn_Array[0];
			document.getElementById("st_cond2").innerText = STF_CondEn_Array[1];
			document.getElementById("st_cond3").innerText = STF_CondEn_Array[2];
			document.getElementById("st_cond4").innerText = STF_CondEn_Array[3];
		} else {
			document.getElementById("st_day1").innerHTML = weekdaysArray_fr[STF_DOW_1].substr(0,3)+". "+periodsArray_fr[STF_Perno_1];
			document.getElementById("st_day2").innerHTML = weekdaysArray_fr[STF_DOW_2].substr(0,3)+". "+periodsArray_fr[STF_Perno_2];
			document.getElementById("st_day3").innerHTML = weekdaysArray_fr[STF_DOW_3].substr(0,3)+". "+periodsArray_fr[STF_Perno_3];
			document.getElementById("st_day4").innerHTML = weekdaysArray_fr[STF_DOW_4].substr(0,3)+". "+periodsArray_fr[STF_Perno_4];
			document.getElementById("st_cond1").innerText = STF_CondFr_Array[0];
			document.getElementById("st_cond2").innerText = STF_CondFr_Array[1];
			document.getElementById("st_cond3").innerText = STF_CondFr_Array[2];
			document.getElementById("st_cond4").innerText = STF_CondFr_Array[3];
		}

		document.getElementById("warningsbar").style.display="none";
		document.getElementById("wrap_obs").style.display="none";
		document.getElementById("wrap_sterm").style.display="block";
		document.getElementById("wrap_lterm").style.display="none";	
		document.getElementById("nav_current_link").style.color="#fff";
		document.getElementById("nav_sterm_link").style.display="block";
		document.getElementById("nav_sterm_link").style.color="#fd0";
		document.getElementById("nav_lterm_link").style.color="#fff";	
	
		widget.setPreferenceForKey("st",createPref("activelayer"));
		
		makePOSTRequest("Short Term");
}

function showLT() {		
	resetLT();
	
	checkVersion();
	
	lang=widget.preferenceForKey(createPref("lang"));
	
	//convertDate(LTDate);
	
	if(lang=="en") { 
		if(LTF_DOW_1!="") {
			document.getElementById("lt_day1").innerHTML = weekdaysArray_en[LTF_DOW_1].substr(0,3).toUpperCase();
			document.getElementById("lt_cond1").innerText = LTF_CondEn_Array[0];
			document.getElementById("lt_icon1").src = "images/icons/small/"+LTF_Icon_Array[0]+".png";
			document.getElementById("lt_temp1").innerHTML = convertTemp(LTF_Temp_1)+tempunitdisplay;
			document.getElementById("lt_low1").innerHTML = getLocalizedString("Low")+convertTemp(LTF_Low_1)+tempunitdisplay;
		} 
		if(LTF_DOW_2!="") {
			document.getElementById("lt_day2").innerHTML = weekdaysArray_en[LTF_DOW_2].substr(0,3).toUpperCase();
			document.getElementById("lt_cond2").innerText = LTF_CondEn_Array[1];
			document.getElementById("lt_icon2").src = "images/icons/small/"+LTF_Icon_Array[1]+".png";
			document.getElementById("lt_temp2").innerHTML = convertTemp(LTF_Temp_2)+tempunitdisplay;
			document.getElementById("lt_low2").innerHTML = getLocalizedString("Low")+convertTemp(LTF_Low_2)+tempunitdisplay;

		}
		if(LTF_DOW_3!="") { 	
			document.getElementById("lt_day3").innerHTML = weekdaysArray_en[LTF_DOW_3].substr(0,3).toUpperCase();
			document.getElementById("lt_cond3").innerText = LTF_CondEn_Array[2];
			document.getElementById("lt_icon3").src = "images/icons/small/"+LTF_Icon_Array[2]+".png";
			document.getElementById("lt_temp3").innerHTML = convertTemp(LTF_Temp_3)+tempunitdisplay;
			document.getElementById("lt_low3").innerHTML = getLocalizedString("Low")+convertTemp(LTF_Low_3)+tempunitdisplay;
		}
		if(LTF_DOW_4!="") {
			document.getElementById("lt_day4").innerHTML = weekdaysArray_en[LTF_DOW_4].substr(0,3).toUpperCase();
			document.getElementById("lt_cond4").innerText = LTF_CondEn_Array[3];
			document.getElementById("lt_icon4").src = "images/icons/small/"+LTF_Icon_Array[3]+".png";
			document.getElementById("lt_temp4").innerHTML = convertTemp(LTF_Temp_4)+tempunitdisplay;
			document.getElementById("lt_low4").innerHTML = getLocalizedString("Low")+convertTemp(LTF_Low_4)+tempunitdisplay;
		} 
		if(LTF_DOW_5!="") { 
			document.getElementById("lt_day5").innerHTML = weekdaysArray_en[LTF_DOW_5].substr(0,3).toUpperCase(); 
			document.getElementById("lt_cond5").innerText = LTF_CondEn_Array[4];
			document.getElementById("lt_icon5").src = "images/icons/small/"+LTF_Icon_Array[4]+".png";
			document.getElementById("lt_temp5").innerHTML = convertTemp(LTF_Temp_5)+tempunitdisplay;
			document.getElementById("lt_low5").innerHTML = getLocalizedString("Low")+convertTemp(LTF_Low_5)+tempunitdisplay;
		}	
	} else { 
		if(LTF_DOW_1!="") {
			document.getElementById("lt_day1").innerHTML = weekdaysArray_fr[LTF_DOW_1].substr(0,3).toUpperCase();
			document.getElementById("lt_cond1").innerText = LTF_CondFr_Array[0];
			document.getElementById("lt_icon1").src = "images/icons/small/"+LTF_Icon_Array[0]+".png";
			document.getElementById("lt_temp1").innerHTML = convertTemp(LTF_Temp_1)+tempunitdisplay;
			document.getElementById("lt_low1").innerHTML = getLocalizedString("Low")+convertTemp(LTF_Low_1)+tempunitdisplay;
		}
		if(LTF_DOW_2!="") {
			document.getElementById("lt_day2").innerHTML = weekdaysArray_fr[LTF_DOW_2].substr(0,3).toUpperCase();
			document.getElementById("lt_cond2").innerText = LTF_CondFr_Array[1];
			document.getElementById("lt_icon2").src = "images/icons/small/"+LTF_Icon_Array[1]+".png";
			document.getElementById("lt_temp2").innerHTML = convertTemp(LTF_Temp_2)+tempunitdisplay;
			document.getElementById("lt_low2").innerHTML = getLocalizedString("Low")+convertTemp(LTF_Low_2)+tempunitdisplay;

		}
		if(LTF_DOW_3!="") { 	
			document.getElementById("lt_day3").innerHTML = weekdaysArray_fr[LTF_DOW_3].substr(0,3).toUpperCase();
			document.getElementById("lt_cond3").innerText = LTF_CondFr_Array[2];
			document.getElementById("lt_icon3").src = "images/icons/small/"+LTF_Icon_Array[2]+".png";
			document.getElementById("lt_temp3").innerHTML = convertTemp(LTF_Temp_3)+tempunitdisplay;
			document.getElementById("lt_low3").innerHTML = getLocalizedString("Low")+convertTemp(LTF_Low_3)+tempunitdisplay;
		}
		if(LTF_DOW_4!="") {
			document.getElementById("lt_day4").innerHTML = weekdaysArray_fr[LTF_DOW_4].substr(0,3).toUpperCase();
			document.getElementById("lt_cond4").innerText = LTF_CondFr_Array[3];
			document.getElementById("lt_icon4").src = "images/icons/small/"+LTF_Icon_Array[3]+".png";
			document.getElementById("lt_temp4").innerHTML = convertTemp(LTF_Temp_4)+tempunitdisplay;
			document.getElementById("lt_low4").innerHTML = getLocalizedString("Low")+convertTemp(LTF_Low_4)+tempunitdisplay;
		}								
		if(LTF_DOW_5!="") { 
			document.getElementById("lt_day5").innerHTML = weekdaysArray_fr[LTF_DOW_5].substr(0,3).toUpperCase(); 
			document.getElementById("lt_cond5").innerText = LTF_CondFr_Array[4];
			document.getElementById("lt_icon5").src = "images/icons/small/"+LTF_Icon_Array[4]+".png";
			document.getElementById("lt_temp5").innerHTML = convertTemp(LTF_Temp_5)+tempunitdisplay;
			document.getElementById("lt_low5").innerHTML = getLocalizedString("Low")+convertTemp(LTF_Low_5)+tempunitdisplay;
		}	
	}

	document.getElementById("warningsbar").style.display="none";
	document.getElementById("wrap_obs").style.display="none";
	document.getElementById("wrap_sterm").style.display="none";
	document.getElementById("wrap_lterm").style.display="block";
	document.getElementById("nav_current_link").style.color="#fff";
	document.getElementById("nav_sterm_link").style.color="#fff";
	document.getElementById("nav_lterm_link").style.color="#fd0";	
	
	widget.setPreferenceForKey("lt",createPref("activelayer"));
	
	makePOSTRequest("Long Term");
}

function resetObs() {
	document.getElementById("obsicon").src = "images/icons/large/0.png";	
	document.getElementById("obstemp").innerHTML = "";
	document.getElementById("obscond").innerText = "";
	document.getElementById("detailedobs").innerHTML = "";
	document.getElementById("updated").innerHTML = "";
}

function resetST() {
	document.getElementById("st_icon1").src = "images/icons/small/0.png";
	document.getElementById("st_icon2").src = "images/icons/small/0.png";
	document.getElementById("st_icon3").src = "images/icons/small/0.png";
	document.getElementById("st_icon4").src = "images/icons/small/0.png";
	document.getElementById("st_temp1").innerHTML = "";
	document.getElementById("st_temp2").innerHTML = "";
	document.getElementById("st_temp3").innerHTML = "";
	document.getElementById("st_temp4").innerHTML = "";
	document.getElementById("st_pop1").innerText = "";;
	document.getElementById("st_pop2").innerText = "";
	document.getElementById("st_pop3").innerText = "";
	document.getElementById("st_pop4").innerText = "";
	document.getElementById("st_day1").innerHTML = "";
	document.getElementById("st_day2").innerHTML = "";
	document.getElementById("st_day3").innerHTML = "";
	document.getElementById("st_day4").innerHTML = "";
	document.getElementById("st_cond1").innerText = "";
	document.getElementById("st_cond2").innerText = "";
	document.getElementById("st_cond3").innerText = "";
	document.getElementById("st_cond4").innerText = "";
}

function resetLT() {
	document.getElementById("lt_day1").innerHTML = ""; 
	document.getElementById("lt_day2").innerHTML = ""; 
	document.getElementById("lt_day3").innerHTML = ""; 
	document.getElementById("lt_day4").innerHTML = ""; 
	document.getElementById("lt_day5").innerHTML = ""; 
	document.getElementById("lt_cond1").innerText = "";
	document.getElementById("lt_cond2").innerText = "";
	document.getElementById("lt_cond3").innerText = "";
	document.getElementById("lt_cond4").innerText = "";
	document.getElementById("lt_cond5").innerText = "";
	document.getElementById("lt_icon1").src = "images/icons/small/0.png";
	document.getElementById("lt_icon2").src = "images/icons/small/0.png";
	document.getElementById("lt_icon3").src = "images/icons/small/0.png";
	document.getElementById("lt_icon4").src = "images/icons/small/0.png";
	document.getElementById("lt_icon5").src = "images/icons/small/0.png";
	document.getElementById("lt_temp1").innerHTML = "";
	document.getElementById("lt_temp2").innerHTML = "";
	document.getElementById("lt_temp3").innerHTML = "";
	document.getElementById("lt_temp4").innerHTML = "";
	document.getElementById("lt_temp5").innerHTML = "";
	document.getElementById("lt_low1").innerHTML = "";
	document.getElementById("lt_low2").innerHTML = "";
	document.getElementById("lt_low3").innerHTML = "";
	document.getElementById("lt_low4").innerHTML = "";
	document.getElementById("lt_low5").innerHTML = "";
			
}

function updateWarnings() {
	
	placecode=widget.preferenceForKey(createPref("placecode"));
	
	// CHECK FOR WARNINGS NOW...
	var rnd = Math.floor(Math.random()*1000000);
	
	URL = wxEyeServer_data+"WarningData/"+placecode+".xml?rnd="+rnd;
	//URL = "caon0696.xml";

	warn_req = new XMLHttpRequest();					
	warn_req.onreadystatechange=getWarningsData;
	warn_req.open("GET", URL, true);
	warn_req.send(null);
}

function getWarningsData() {
	lang=widget.preferenceForKey(createPref("lang"));
	langUpper=lang.toUpperCase();
	
	if (warn_req.readyState==4) {
	
		status = warn_req.status;

		if (status == 200) {
			var warn_xml = warn_req.responseXML;								
			// If there's a Warning tag in the XML returned there's must be a warning for that place
		
			var warn_tag=warn_xml.getElementsByTagName("data");
		
			if(warn_tag[0].childNodes.length > 0) {
		
				for(i=0;i<warn_tag[0].childNodes.length;i++) {
					warn_source=warn_tag[0].childNodes[i].getAttribute("source");
					if(warn_tag[0].childNodes[i].getAttribute("lang")==langUpper) { 
						if(warn_tag[0].childNodes[i].firstChild != null) { 
							warn_array[0] = warn_tag[0].childNodes[i].firstChild.getAttribute("n");
							warn_array[1] = warn_tag[0].childNodes[i].firstChild.getAttribute("name");		
							warningActive=true;
						}	
					} 
				}
		
				if(warn_array.length>0) {						
					WxWarnRegion = warn_array[0].split("-");
					WxWarnLink = "http://weyedata.pelmorex.com/WeatherEyeRedirect/links.asp?lang="+lang+"&product=alerts&app=vgadget&version="+version+"&stationCode="+WxWarnRegion[1];									
					WxWarnName=warn_array[1];
					numwarnings++;
				}
		
				if(warningActive==true){
					if((WxWarnName.length)>32) { WxWarnName = WxWarnName.substring(0,32) + "..."; }
		
					document.getElementById("warningslink").innerText = WxWarnName;	
					document.getElementById("warningslink").href = "javascript:widget.openURL(WxWarnLink)";	
		
					if(warn_source=="ACA") {
						document.getElementById("warningsbar").style.background = "url(images/warnbar_blue.png) no-repeat top left";
					} else {
						document.getElementById("warningsbar").style.background = "url(images/warnbar_red.png) no-repeat top left";
					}
					
					document.getElementById("warningsbar").style.display = "block";	
					
					widget.setPreferenceForKey("true",createPref("warningflag")); 
		
				} else {					
					warningActive=false;
					WxWarnName="";
					numwarnings=0;
					//document.getElementById("warningsdesc").innerText = "";
					//document.getElementById("warningslink").href = "";		
					document.getElementById("warningsbar").style.display = "none";
					widget.setPreferenceForKey("false",createPref("warningflag")); 				
				}
				
			} else {
				warningActive=false;
				WxWarnName="";
				numwarnings=0;
				//document.getElementById("warningsdesc").innerText = "";
				//document.getElementById("warningslink").href = "";		
				document.getElementById("warningsbar").style.display = "none";
				widget.setPreferenceForKey("false",createPref("warningflag")); 
			}			
		} else {
			warningActive=false;
			WxWarnName="";
			numwarnings=0;
			//document.getElementById("warningsdesc").innerText = "";
			//document.getElementById("warningslink").href = "";		
			document.getElementById("warningsbar").style.display = "none";
			widget.setPreferenceForKey("false",createPref("warningflag")); 
		}
	}
}

function convertTemp(tempInC) {
	tempunit=widget.preferenceForKey(createPref("tempunit"));
	if (tempunit=="F")	{
		return Math.round((9/5)*tempInC+32);
	} else {
		return tempInC;
	}
}

function show() {
    /*if ( !timerId ) {
        timerId = setInterval( "updateWeather(false);", updateWeatherTimeout );
    }*/
	city=widget.preferenceForKey(createPref("selectedcity_en"));
	if (typeof city == "undefined") {
		showBack(); 
	} else { 
		showFront(); 
	}
}

function hide() {
    // Clear timer
    if (timerId) {
        clearInterval( timerId );
        timerId = 0;
    }
}

function remove() {
    // Clear timer
    if ( timerId ) {
        clearInterval( timerId );
        timerId = 0;
    }
	
	if (window.widget) {
		widget.setPreferenceForKey(null,createPref("activelayer")); 	
		widget.setPreferenceForKey(null,createPref("selectedcity_en"));
		widget.setPreferenceForKey(null,createPref("selectedcity_fr"));
		widget.setPreferenceForKey(null,createPref("placecode"));
		widget.setPreferenceForKey(null,createPref("tempunit"));
		widget.setPreferenceForKey(null,createPref("lang"));
		widget.setPreferenceForKey(null,createPref("warningflag")); 
		widget.setPreferenceForKey(null,createPref("birthyear"));
		widget.setPreferenceForKey(null,createPref("gender")); 	
	}
}


function changeUnits(units) {
	// Get the value of the selected language item
	var unitsSelected = tempunits.options[tempunits.options.selectedIndex].value;

	// Store it in the Preference key "tempunits"
	widget.setPreferenceForKey(unitsSelected, createPref("tempunit"));

	tempunit = unitsSelected;
	
	activelayer = widget.preferenceForKey(createPref("activelayer"));

	// Update the interface to reflect this change
	updateWeather(activelayer);
}

function changeLang(lang) {

	// Get the value of the selected language item
	var langSelected = langsetting.options[langsetting.options.selectedIndex].value;

	// Store it in the Preference key "lang"
	widget.setPreferenceForKey(langSelected,createPref("lang"));
	
	activelayer = widget.preferenceForKey(createPref("activelayer"));

	// Set the strings
	setLocalizedStrings(langSelected);

	// Retrieve the FX again to get new days Name and forecast conditions
	updateWeather(activelayer);
}

function createPref(pref) {
	//set a preference per unique widget instance.
	return widget.identifier + ": " + pref;
}

function checkVersion() {
	var rnd = Math.floor(Math.random()*1000000);
	URL = "http://weathercentre.pelmorex.com/weathereye/MacOS/en/WeatherEyeMacUpdate.xml?rnd="+rnd;
	req = new XMLHttpRequest();	
	req.onreadystatechange = getNewVersion;
	req.open("GET", URL, true);
	req.send(null);
}

function getNewVersion() {
	lang = widget.preferenceForKey(createPref("lang"));

	if (req.readyState==4) {
		status = req.status;

		if (status == 200) {
			var ver_xml = req.responseXML;
			newVersion = ver_xml.getElementsByTagName("version")[0].firstChild.data;
			try
			{
				if (newVersion != "") {
					if (lang == "fr") {
						ver_message = ver_xml.getElementsByTagName("message_fr")[0].firstChild.data;
						//shortMessage = ver_xml.getElementsByTagName("shortMessage_fr")[0].firstChild.data;
						ver_link = ver_xml.getElementsByTagName("updateURL_fr")[0].firstChild.data;
					} else {
						ver_message = ver_xml.getElementsByTagName("message_en")[0].firstChild.data;
						//shortMessage = ver_xml.getElementsByTagName("shortMessage_en")[0].firstChild.data;
						ver_link = ver_xml.getElementsByTagName("updateURL_en")[0].firstChild.data;
					}
					

					if (newVersion > currVersion) {
						alert("yes");
						document.getElementById("updatelink").innerText = ver_message;	
						document.getElementById("updatelink").href = "javascript:widget.openURL(ver_link)";	
						document.getElementById("updatebar").style.display = "block";		
						/*if(!warningActive) { document.getElementById("updatebar").style.display = "block"; }
						else { document.getElementById("updatebar").style.display = "none";	}*/
					} else {
						alert("no");
						document.getElementById("updatebar").style.display = "none";	
					}

				}
			} catch (e) {
				document.getElementById("updatebar").style.display = "none";	
			}
		} 
	}
}

function convertTime(militarytime) {
	var splitTime = militarytime.split(":");
	var hours = splitTime[0];
	var minutes = splitTime[1];
	 
	
	// add "AM" or "PM" if the 12-hours format is chosen
	var ampm = ((hours >= 12) ? " PM" : " AM");
	
	// convert the hour to 12-hours format
	// javascript returns midnight as 0, but since the time is in the 12-hours format
	// force javascript to return 12
	hours = ((hours == 0) ? "12" : (hours > 12) ? hours - 12 : hours);
	
	var convertedTime = hours + ":" + minutes + " " + ampm;
	
	return convertedTime;
}


function makePOSTRequest(section) {
	lang=widget.preferenceForKey(createPref("lang"));
	
	if(lang=="en") { city=widget.preferenceForKey(createPref("selectedcity_en")); }
	else { city=widget.preferenceForKey(createPref("selectedcity_fr")); }
	
	/*if(warningactive) { warncity=city; }*/
	
	province = widget.preferenceForKey(createPref("placecode")).substr(2,2);	
	if(province=="XX") { province=""; }
	
	country=widget.preferenceForKey(createPref("placecode")).substr(0,2);
		
	alert(province);
	
	var osver = "Mac OS X " + widget.system("/usr/bin/sw_vers -productVersion", null).outputString;	
	
	
	alert("osver: " + osver);
	
	var guid = widget.identifier;
	
	birthyear=widget.preferenceForKey(createPref("birthyear"));
	gender=widget.preferenceForKey(createPref("gender"));	

	var curDate = new Date();
	var data = '<?xml version="1.0" encoding="UTF-8"?>' +
	'	<request>' +
	'		<scXmlVer>1.0</scXmlVer>' +
	'		<reportSuiteID>pelmedwxeyemac</reportSuiteID>' +
	'		<visitorID>'+guid+'</visitorID>' +
	'		<timestamp>' + curDate.getFullYear() + '-';

				//2009.2.19 Build timestamp
				var actualMonth = curDate.getMonth() + 1;
				if (actualMonth < 10) {
					data = data + '0' + actualMonth;
				} else {
					data = data + actualMonth;
				}

				data = data + '-';

				if (curDate.getDate() < 10) {
					data = data + '0' + curDate.getDate();
				} else {
					data = data + curDate.getDate();
				}

				data = data + 'T';

				if (curDate.getHours() < 10) {
					data = data + '0' + curDate.getHours();
				} else {
					data = data + curDate.getHours();
				}

				data = data + ':';

				if (curDate.getMinutes() < 10) {
					data = data + '0' + curDate.getMinutes();
				} else {
					data = data + curDate.getMinutes();
				}

				data = data + ':';

				if (curDate.getSeconds() < 10) {
					data = data + '0' + curDate.getSeconds();
				} else {
					data = data + curDate.getSeconds();
				}

				data = data + '-05</timestamp>' +
	'		<ipAddress>127.0.0.1</ipAddress>' +
	'		<pageURL></pageURL>' +
	'		<pageName>'+section+': '+city+'</pageName>' +
	'		<channel>'+section+'</channel>' +
	'		<prop1>'+guid+'</prop1>' +
	'		<prop2>'+lang+'</prop2>' +
	'		<prop3>'+city+'</prop3>' +
	'		<prop4>'+province+'</prop4>' +
	'		<prop5>'+country+'</prop5>' +
	'		<prop6></prop6>' +
	'		<prop7>'+currVersion+'</prop7>' +
	'		<prop8></prop8>' +
	'		<prop9></prop9>' +
	'		<prop10>'+osver+'</prop10>' +
	'		<prop11></prop11>' +
	'		<prop12>'+birthyear+'</prop12>' +
	'		<prop13>'+gender+'</prop13>' +
	'	</request>';

	var xhReq = new XMLHttpRequest();
	var url = "http://pelmedwxeyemac.122.2o7.net/b/ss//6";
	xhReq.open("POST", url, false);
	xhReq.send(data);
	var serverResponse = xhReq.responseText;
}


if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
}

/*if (window.addEventListener) {
	var kkeys = [], konami = "38,38,40,40,37,39,37,39,66,65";
	window.addEventListener("keydown", function(e){
    	kkeys.push( e.keyCode );
        if ( kkeys.toString().indexOf( konami ) >= 0 )
        //widget.openURL("http://www.homestarrunner.com/sbemail45.swf"); 
	}, true);
}*/
